#include <iostream>
using namespace std;
const long long mod = 1e9 + 7;
long long dp[5100][5104][2];
long long sumto[5104][5104];
long long sumfrom[5104][5104];
//dp[sum][last][sign]
long long n;
int main() {
    long long k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    dp[k][k][0] = 1;
    dp[k][k][1] = 1;

    for (long long i = 1; i <= k; i++) {
        sumfrom[k][i] = 1;
    }
    for (long long i = k; i <= n; i++) {
        sumto[k][i] = 1;
    }

    for (long long i = k + 1; i <= n; i++) {
        for (long long j = 1; j <= n; j++) {
            if (i < j) continue;
            dp[i][j][0] = sumto[i - j][j - 1];
            dp[i][j][1] = sumfrom[i - j][j + 1];
        }

        for (long long j = 1; j <= n; j++) {
            sumto[i][j] = sumto[i][j - 1] + dp[i][j][1];
            sumto[i][j] %= mod;
        }

        sumfrom[i][n] = dp[i][n][0];
        for (long long k = n - 1; k >= 0; k--) {
            sumfrom[i][k] = sumfrom[i][k + 1] + dp[i][k][0];
            sumfrom[i][k] %= mod;
        }

    }
    long long ans = 0;
    for (long long i = 1; i <= n; i++) {
        ans += dp[n][i][0] + dp[n][i][1];
        ans %= mod;
    }
    cout << ans;
}
